#The following code allows the user to recreate the data that is provided in Table A.1.1 of the report

#First set the working directory
setwd("C:/Users/kvincent/Desktop/MoH PCA project/Kyle's work")
#Read in all the data
Data_All = read.csv("Complete Reduced Database Final.csv",header=TRUE)

#Removing the preamble
Data_sub_All = read.csv("Data Working Version.csv",header=TRUE)
#Data_sub_All contains the former assignment of dissemination areas to local health areas

#Upload the British Columbia Ministry of Health's file
New_LHAs = read.csv("DA_CSD_LHA_2006_Jeet_Rana.csv",header=TRUE)

#The Unused_New_LHAs are those dissemination areas that are not included in our oringial data set and can not be used due to an absence of reported income/census data
#Here are the unused dissemination areas, there are 1,031 of them
Unused_New_LHAs = subset(New_LHAs,New_LHAs[,1] %in% intersect(New_LHAs[,1],Data_sub_All[,2])==FALSE)

#Here are the new assignments for the 6,440 dissemination areas
New_LHAs = subset(New_LHAs,New_LHAs[,1] %in% intersect(New_LHAs[,1],Data_sub_All[,2]))

#Carry the new assignments over to our original census data set
Data_sub_All[,6:7] = New_LHAs[,3:4] #Update the file we work with

#Reading in more files
DA = read.csv("DA.csv",header=TRUE)
DA_reduced = read.csv("DA_reduced.csv",header=TRUE)
DA_Jana = read.csv("DA_CSD_LHA_2006_Jeet_Rana.csv",header=TRUE)

DA_Jana[which(is.na(DA_Jana[,5])==TRUE),1]			#These dissemination areas are actually missing population counts, we will give them a zero for now
DA_Jana[which(is.na(DA_Jana[,5])),5] = 0

#Which dissemination areas in Stats Can's master list do we not have data for
Missing_DA = setdiff(DA_Jana[,1],Data_sub_All[,2])

#The population counts
Missing_Pop = numeric()

for(k in 1:length(Missing_DA))
	Missing_Pop[k] = DA_Jana[which(Missing_DA[k]==DA_Jana[,1]),5]

hist(Missing_Pop)


#The population counts for all of the data	
X11(); hist(DA_Jana[,5])

#The number of missing DAs that have a zero count for population
length(which(Missing_Pop==0))
#The total number of DAs that have a zero count for population
length(which(DA_Jana[,5]==0))

#Consider the proportion of dissemination areas that are missing from each LHA
LHAs = levels(DA_Jana[,4])
True_counts_DAs = numeric(89)
Our_counts_DAs = numeric(89)

num_var = dim(DA_Jana)[1]
jj = 0
for(k in levels(DA_Jana[,4]))
	{
	j = 0
	for(i in 1:num_var)
		if(DA_Jana[i,4] == k)
			j = j+1
	jj = jj+1
	True_counts_DAs[jj] = j
	}	

num_var = dim(Data_sub_All)[1]
jj = 0
for(k in levels(DA_Jana[,4]))
	{
	j = 0
	for(i in 1:num_var)
		if(Data_sub_All[i,7] == k)
			j = j+1
	jj = jj+1
	Our_counts_DAs[jj] = j
	}		

#Now to consider the proportion of the population that is missing from each LHA
LHAs = levels(DA_Jana[,4])
True_counts_pop = numeric(89)
Our_counts_pop = numeric(89)
for(k in 1:7471)
	{
	x = DA_Jana[k,4]
	True_counts_pop[which(LHAs==x)] = True_counts_pop[which(LHAs==x)] + DA_Jana[k,5]
	}
	
for(k in 1:7471)
	{
	if(DA_Jana[k,1] %in% Missing_DA==FALSE)
		{
		x = DA_Jana[k,4]
		Our_counts_pop[which(LHAs==x)] = Our_counts_pop[which(LHAs==x)] + DA_Jana[k,5]
		}
	}	

#The final table
cbind(LHAs,True_counts_DAs,Our_counts_DAs,Our_counts_DAs/True_counts_DAs,True_counts_pop,Our_counts_pop,Our_counts_pop/True_counts_pop)	
